# -*- coding: UTF-8 -*-
# -*- Mode: Python; py-indent-offset: 4 -*-
# Authors: Nik Kim <fafhrd@legco.biz> 

import Products
from AccessControl import Permissions
from AccessControl.Permission import _registeredPermissions
from AccessControl.Permission import pname
from AccessControl.PermissionRole import rolesForPermissionOn

from Globals import ApplicationDefaultPermissions

def setDefaultRoles(permission, roles):
    '''
    Sets the defaults roles for a permission.
    '''
    # XXX This ought to be in AccessControl.SecurityInfo.
    registered = _registeredPermissions
    if not registered.has_key(permission):
        registered[permission] = 1
        Products.__ac_permissions__=(
            Products.__ac_permissions__+((permission,(),roles),))
        mangled = pname(permission)
        setattr(ApplicationDefaultPermissions, mangled, roles)


ScheduleTasks = 'ZopeScheduler: Schedule tasks'
setDefaultRoles( ScheduleTasks, ( 'Manager', ) )

ManageSchedulingTask = 'ZopeScheduler: Manage scheduling task'
setDefaultRoles( ManageSchedulingTask, ( 'Manager', 'Owner' ) )
